program Text(output);
var
   pc : integer;

   procedure syntax;
   begin
      writeln('Text - Converts text files');
      writeln('Syntax: ivm text filespec1, ... filespecN');
      writeln('        The wildcards ''?'' and ''*'' may be used');
      writeln('For example:');
      writeln('        ivm text *.pas *.txt');
      writeln('  Converts all the text files with extensions');
      writeln('  .pas or .txt in the current directory');
      halt
   end;

   procedure ConvertFile(f : filename);
   var
      DirPart, NamePart, ExtPart : filename;
      fname : filename;
      d : Dir;

      function FileMatch(fspec, fname : filename) : boolean;
      var
         SpecPos, NamePos : integer;
         next : char;
         done : boolean;
      begin
         if (platform <> platform_linux) and (platform <> platform_fbsd) then
            begin
               fspec := lowercase(fspec);
               fname := lowercase(fname)
            end;
         NamePos := 1;
         SpecPos := 1;
         done := false;
         repeat
            (*
            writeln(fspec, '-', fname);
            writeln(SpecPos, NamePos);
            *)
            if (SpecPos>length(fspec)) and (NamePos>length(fname)) then
               begin
                  FileMatch := true;
                  done := true
               end
            else if (SpecPos>length(fspec)) and (NamePos<=length(fname)) then
               begin
                  FileMatch := false;
                  done := true
               end
            else if (SpecPos<=length(fspec)) and (NamePos>length(fname)) then
               begin
                  FileMatch := false;
                  done := true
               end
            else if fspec[SpecPos] = '?' then
               begin
                  inc(SpecPos);
                  inc(NamePos)
               end
            else if fspec[SpecPos] = '*' then
               begin
                  if SpecPos = length(fspec) then
                     begin
                        FileMatch := true;
                        done := true
                     end
                  else
                     begin
                        next := fspec[SpecPos+1];
                        NamePos := pos(next, fname, NamePos);
                        if NamePos > 0 then
                           inc(SpecPos)
                        else
                           begin
                              FileMatch := false;
                              done := true
                           end
                     end
               end
            else if fspec[SpecPos] = fname[NamePos] then
               begin
                  inc(SpecPos);
                  inc(NamePos)
               end
            else
               begin
                  FileMatch := false;
                  done := true
               end
         until done;
      end;

      procedure DoConvert(name : filename);
      const
         OutExt = 'out';
      var
         DirPart, NamePart, ExtPart : filename;
         fIn, fOut : text;
         line : string;
      begin
         fsplit(name, DirPart, NamePart, ExtPart);
         assign(fIn, name);
         reset(fIn);
         assign(fOut, DirPart+NamePart+'.'+OutExt);
         rewrite(fOut);
         while not eof(fIn) do
            begin
               readln(fIn, line);
               writeln(fOut, line);
            end;
         close(fIn);
         close(fOut)
      end;

   begin	(* ConvertFile *)
      f := fexpand(f);
      writeln(f);
      fsplit(f, DirPart, NamePart, ExtPart);
      OpenDir(d, DirPart);
      repeat
         ReadDir(d, fname);
         if fname <> '' then
            begin
               if FileMatch(NamePart+ExtPart, fname) then
                  DoConvert(DirPart+fname);
            end
      until fname = '';
      CloseDir(d);
   end;	(* ConvertFile *)

begin
   if paramcount < 1 then
      syntax;
   for pc := 1 to paramcount do
	ConvertFile(paramstr(pc));
end.
